(function (window, rJS) {
	"use strict";
	rJS(window)
	.setState({
		update: false
	})
	.declareService(function () {
		var gadget = this;
		CodeMirror.fromTextArea(document.getElementById("editor"), {
			mode: {
				name: "htmlmixed",
				tags: {
					style: [["type", /^text\/(x-)?scss$/, "text/x-scss"],
							[null, null, "css"]]
				}
			},
			theme: "mdn-like",
			lineNumbers: true,
			smartIndent: true,
			indentWithTabs: true,
			indentUnit: 4,
			tabsize: 4
		});
		var editor = document.querySelector(".CodeMirror").CodeMirror
		editor.on("change", function (event) {
			document.getElementById('convert').style.border = "";
		})
	})
	.onEvent("click", function (event) {
		var gadget = this;
		switch (event.target.className.trim())
		{
		case "convert":
			return gadget.changeState({update: true});
		}
	})
	.onStateChange(function (ignored) {
		var gadget = this;
		var editor = document.querySelector(".CodeMirror").CodeMirror;
		var viewer = document.getElementById("viewer");
		var button = document.getElementById('convert');
		var converter;

		return gadget.getDeclaredGadget("converter")
			.push(function (subgadget) {
				converter = subgadget;
				button.style.border = "2px solid orange";
				let html = editor.getValue();
				return converter.convert(html);
			})
			.push(function (base64data) {
				button.style.border = "2px solid green";
				viewer.src = "data:application/pdf;base64," + base64data;
			})
			.push(function () {
				gadget.state.update = false;
			})
	})
}(window, rJS));